#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK0x0x0NN1x1x1_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const float *stM = A + (((Mb) << 1));
   const float *stN = B + (((ldb*Nb) << 1));
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 2 - (((Kb*lda) << 1)), incAn = -(((Mb) << 1));
   #define incBk 2
   const int incBm = -(((Kb) << 1)), incBn = (((ldb) << 1));
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=K; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK0x0x0NN1x1x4_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=4, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const int Kloop = ((K-2)>>2)<<2, kr = K - Kloop - 2;
   const float *stM = A + (((Mb) << 1));
   const float *stN = B + (((ldb*Nb) << 1));
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 2 - (((Kb*lda) << 1)), incAn = -(((Mb) << 1));
   #define incBk 8
   const int incBm = -(((Kb) << 1)), incBn = (((ldb) << 1));
   #define incAk0 incAk
   const int incBk0 = ((incBk) >> 2);
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float m0;
   register float rC0_0;
   if (K < 3)
   {
      ATL_cJIK0x0x0NN1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         pA0 += incAk0;
         rA0 = *pA0;
         rB0 = pB0[2];

         pB0 += (incBk0);
         for (k=Kloop; k; k -= 4) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            pB0 += incBk;
         } /* end K-loop */
         switch(kr)
         {
         case 1:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            pB0 += (incBk0);
            break;
         case 2:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            pB0 += (((incBk0) << 1));
            break;
         case 3:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            pB0 += (((incBk0) << 1)+incBk0);
            break;
         case 0: ;
         }
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         pA0 += incAk0;
         rC0_0 += m0;
         pB0 += incBk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK0x0x0NN0x0x0_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=4, ku=4, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   const int Nb = (N>>2)<<2;
   #define Kb K
   const int Kloop = ((K-1)>>2)<<2, kr = K - Kloop - 1;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 1));
   const float *stN = B + (((ldb*Nb) << 1));
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 2 - (((Kb*lda) << 1)), incAn = -(((Mb) << 1));
   #define incBk 8
   const int incBm = -(((Kb) << 1)), incBn = (((ldb) << 3));
   #define incAk0 incAk
   const int incBk0 = ((incBk) >> 2);
   #define incCm 2
   const int incCn = (((ldc) << 3)) - (((Mb) << 1));
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B, *pB1=pB0+(((ldb) << 1)), *pB2=pB1+(((ldb) << 1)), *pB3=pB2+(((ldb) << 1));
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3;
   register float m0, m1;
   register float rC0_0, rC0_1, rC0_2, rC0_3;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = *pB1;
            rB2 = *pB2;
            m0 = rA0 * rB0;
            rB3 = *pB3;
            m1 = rA0 * rB1;

            for (k=Kloop; k; k -= 4) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC0_1 += m1;
               m1 = rA0 * rB3;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rB3 = pB3[2];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rC0_3 += m1;
               m1 = rA0 * rB1;
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC0_1 += m1;
               m1 = rA0 * rB3;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rB1 = pB1[4];
               rB2 = pB2[4];
               rB3 = pB3[4];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rC0_3 += m1;
               m1 = rA0 * rB1;
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC0_1 += m1;
               m1 = rA0 * rB3;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rB1 = pB1[6];
               rB2 = pB2[6];
               rB3 = pB3[6];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rC0_3 += m1;
               m1 = rA0 * rB1;
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC0_1 += m1;
               m1 = rA0 * rB3;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[8];
               rB1 = pB1[8];
               rB2 = pB2[8];
               rB3 = pB3[8];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rC0_3 += m1;
               m1 = rA0 * rB1;
               pB0 += incBk;
               pB1 += incBk;
               pB2 += incBk;
               pB3 += incBk;
            } /* end K-loop */
            switch(kr)
            {
            case 1:
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC0_1 += m1;
               m1 = rA0 * rB3;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rB3 = pB3[2];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rC0_3 += m1;
               m1 = rA0 * rB1;
               pB0 += (incBk0);
               pB1 += (incBk0);
               pB2 += (incBk0);
               pB3 += (incBk0);
               break;
            case 2:
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC0_1 += m1;
               m1 = rA0 * rB3;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rB3 = pB3[2];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rC0_3 += m1;
               m1 = rA0 * rB1;
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC0_1 += m1;
               m1 = rA0 * rB3;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rB1 = pB1[4];
               rB2 = pB2[4];
               rB3 = pB3[4];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rC0_3 += m1;
               m1 = rA0 * rB1;
               pB0 += (((incBk0) << 1));
               pB1 += (((incBk0) << 1));
               pB2 += (((incBk0) << 1));
               pB3 += (((incBk0) << 1));
               break;
            case 3:
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC0_1 += m1;
               m1 = rA0 * rB3;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rB3 = pB3[2];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rC0_3 += m1;
               m1 = rA0 * rB1;
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC0_1 += m1;
               m1 = rA0 * rB3;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[4];
               rB1 = pB1[4];
               rB2 = pB2[4];
               rB3 = pB3[4];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rC0_3 += m1;
               m1 = rA0 * rB1;
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC0_1 += m1;
               m1 = rA0 * rB3;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[6];
               rB1 = pB1[6];
               rB2 = pB2[6];
               rB3 = pB3[6];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rC0_3 += m1;
               m1 = rA0 * rB1;
               pB0 += (((incBk0) << 1)+incBk0);
               pB1 += (((incBk0) << 1)+incBk0);
               pB2 += (((incBk0) << 1)+incBk0);
               pB3 += (((incBk0) << 1)+incBk0);
               break;
            case 0: ;
            }
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rC0_1 += m1;
            m1 = rA0 * rB3;
            pA0 += incAk0;
            rC0_2 += m0;
            rC0_3 += m1;
            pB0 += incBk0;
            pB1 += incBk0;
            pB2 += incBk0;
            pB3 += incBk0;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC0_1 *= rB0;
            rC0_2 *= rB0;
            rC0_3 *= rB0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            *pC3 = rC0_3;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pA0 += incAm;
            pB0 += incBm;
            pB1 += incBm;
            pB2 += incBm;
            pB3 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pA0 += incAn;
         pB0 += incBn;
         pB1 += incBn;
         pB2 += incBn;
         pB3 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_cJIK0x0x0NN1x1x4_aX_bX(M, k, K, alpha, ca, lda, cb + (((Nb*ldb) << 1)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
