#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_cJIK0x48x48TN48x48x0_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=48, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=1, nu=4, ku=48, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   const float *stM = A + (((Mb) << 5)+((Mb) << 4));
   const float *stN = B + 2304;
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*4)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 48
   const int incAm = 0, incAn = -(((Mb) << 5)+((Mb) << 4));
   #define incBk 48
   const int incBm = -48, incBn = 192;
   const int incAk0 = ((incAk) / 48), incBk0 = ((incBk) / 48);
   #define incCm 2
   const int incCn = (((ldc) << 3)) - (((Mb) << 1));
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3;
   register float m0;
   register float rC0_0, rC0_1, rC0_2, rC0_3;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         rC0_3 = *pC3;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[48];
         rB2 = pB0[96];
         m0 = rA0 * rB0;
         rB3 = pB0[144];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 = m0;
         m0 = rA0 * rB1;
         rC0_1 = m0;
         m0 = rA0 * rB2;
         rC0_2 = m0;
         m0 = rA0 * rB3;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB0[49];
         rB2 = pB0[97];
         rB3 = pB0[145];
         rC0_3 = m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB0[50];
         rB2 = pB0[98];
         rB3 = pB0[146];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rB1 = pB0[51];
         rB2 = pB0[99];
         rB3 = pB0[147];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rB1 = pB0[52];
         rB2 = pB0[100];
         rB3 = pB0[148];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rB1 = pB0[53];
         rB2 = pB0[101];
         rB3 = pB0[149];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rB1 = pB0[54];
         rB2 = pB0[102];
         rB3 = pB0[150];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rB1 = pB0[55];
         rB2 = pB0[103];
         rB3 = pB0[151];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rB1 = pB0[56];
         rB2 = pB0[104];
         rB3 = pB0[152];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rB1 = pB0[57];
         rB2 = pB0[105];
         rB3 = pB0[153];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rB1 = pB0[58];
         rB2 = pB0[106];
         rB3 = pB0[154];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rB1 = pB0[59];
         rB2 = pB0[107];
         rB3 = pB0[155];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rB1 = pB0[60];
         rB2 = pB0[108];
         rB3 = pB0[156];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rB1 = pB0[61];
         rB2 = pB0[109];
         rB3 = pB0[157];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rB1 = pB0[62];
         rB2 = pB0[110];
         rB3 = pB0[158];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rB1 = pB0[63];
         rB2 = pB0[111];
         rB3 = pB0[159];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rB1 = pB0[64];
         rB2 = pB0[112];
         rB3 = pB0[160];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rB1 = pB0[65];
         rB2 = pB0[113];
         rB3 = pB0[161];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rB1 = pB0[66];
         rB2 = pB0[114];
         rB3 = pB0[162];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rB1 = pB0[67];
         rB2 = pB0[115];
         rB3 = pB0[163];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rB1 = pB0[68];
         rB2 = pB0[116];
         rB3 = pB0[164];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rB1 = pB0[69];
         rB2 = pB0[117];
         rB3 = pB0[165];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rB1 = pB0[70];
         rB2 = pB0[118];
         rB3 = pB0[166];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rB1 = pB0[71];
         rB2 = pB0[119];
         rB3 = pB0[167];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rB1 = pB0[72];
         rB2 = pB0[120];
         rB3 = pB0[168];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[25];
         rB0 = pB0[25];
         rB1 = pB0[73];
         rB2 = pB0[121];
         rB3 = pB0[169];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rB1 = pB0[74];
         rB2 = pB0[122];
         rB3 = pB0[170];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[27];
         rB0 = pB0[27];
         rB1 = pB0[75];
         rB2 = pB0[123];
         rB3 = pB0[171];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rB1 = pB0[76];
         rB2 = pB0[124];
         rB3 = pB0[172];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[29];
         rB0 = pB0[29];
         rB1 = pB0[77];
         rB2 = pB0[125];
         rB3 = pB0[173];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rB1 = pB0[78];
         rB2 = pB0[126];
         rB3 = pB0[174];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[31];
         rB0 = pB0[31];
         rB1 = pB0[79];
         rB2 = pB0[127];
         rB3 = pB0[175];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[32];
         rB0 = pB0[32];
         rB1 = pB0[80];
         rB2 = pB0[128];
         rB3 = pB0[176];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[33];
         rB0 = pB0[33];
         rB1 = pB0[81];
         rB2 = pB0[129];
         rB3 = pB0[177];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[34];
         rB0 = pB0[34];
         rB1 = pB0[82];
         rB2 = pB0[130];
         rB3 = pB0[178];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[35];
         rB0 = pB0[35];
         rB1 = pB0[83];
         rB2 = pB0[131];
         rB3 = pB0[179];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[36];
         rB0 = pB0[36];
         rB1 = pB0[84];
         rB2 = pB0[132];
         rB3 = pB0[180];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[37];
         rB0 = pB0[37];
         rB1 = pB0[85];
         rB2 = pB0[133];
         rB3 = pB0[181];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[38];
         rB0 = pB0[38];
         rB1 = pB0[86];
         rB2 = pB0[134];
         rB3 = pB0[182];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[39];
         rB0 = pB0[39];
         rB1 = pB0[87];
         rB2 = pB0[135];
         rB3 = pB0[183];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[40];
         rB0 = pB0[40];
         rB1 = pB0[88];
         rB2 = pB0[136];
         rB3 = pB0[184];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[41];
         rB0 = pB0[41];
         rB1 = pB0[89];
         rB2 = pB0[137];
         rB3 = pB0[185];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[42];
         rB0 = pB0[42];
         rB1 = pB0[90];
         rB2 = pB0[138];
         rB3 = pB0[186];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[43];
         rB0 = pB0[43];
         rB1 = pB0[91];
         rB2 = pB0[139];
         rB3 = pB0[187];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[44];
         rB0 = pB0[44];
         rB1 = pB0[92];
         rB2 = pB0[140];
         rB3 = pB0[188];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[45];
         rB0 = pB0[45];
         rB1 = pB0[93];
         rB2 = pB0[141];
         rB3 = pB0[189];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[46];
         rB0 = pB0[46];
         rB1 = pB0[94];
         rB2 = pB0[142];
         rB3 = pB0[190];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[47];
         rB0 = pB0[47];
         rB1 = pB0[95];
         rB2 = pB0[143];
         rB3 = pB0[191];
         rC0_3 += m0;
         m0 = rA0 * rB0;
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rC0_3 += m0;
         pA0 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANM
#define ATL_cpMBmm_b0 ATL_cgpMBmm_b0
#endif

void ATL_cJIK0x48x48TN48x48x0_a1_b0(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK0x48x48TN48x48x0_a1_bX(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK0x48x48TN48x48x0_a1_b1(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);

void ATL_cpMBmm_b0(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc)
{
   ATL_cJIK0x48x48TN48x48x0_a1_b0(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_cJIK0x48x48TN48x48x0_a1_b0(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_cJIK0x48x48TN48x48x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_cJIK0x48x48TN48x48x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
