#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x0x0TN1x1x10_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=10, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   #define Nb N
   const int Kb = (K/10)*10;
   const double *stM = A + (((lda*Mb) << 1));
   const double *stN = B + (((ldb*Nb) << 1));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 20
   const int incAm = ((((lda) - Kb) << 1)), incAn = -(((Mb*lda) << 1));
   #define incBk 20
   const int incBm = -(((Kb) << 1)), incBn = (((ldb) << 1));
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=Kb; k; k -= 10) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         switch(k = (K-Kb))
         {
         case 1:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            break;
         case 2:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            break;
         case 3:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            break;
         case 4:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            break;
         case 5:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            break;
         case 6:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            break;
         case 7:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += rA0 * rB0;
            break;
         case 8:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += rA0 * rB0;
            break;
         case 9:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += rA0 * rB0;
            break;
         case 0: ;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK0x0x0TN0x0x0_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=4, ku=10, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   const int Nb = (N>>2)<<2;
   const int Kb = (K/10)*10;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((lda*Mb) << 1));
   const double *stN = B + (((ldb*Nb) << 1));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 20
   const int incAm = ((((lda) - Kb) << 1)), incAn = -(((Mb*lda) << 1));
   #define incBk 20
   const int incBm = -(((Kb) << 1)), incBn = (((ldb) << 3));
   #define incCm 2
   const int incCn = (((ldc) << 3)) - (((Mb) << 1));
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(((ldb) << 1)), *pB2=pB1+(((ldb) << 1)), *pB3=pB2+(((ldb) << 1));
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3;
   register double rC0_0, rC0_1, rC0_2, rC0_3;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+8);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            for (k=Kb; k; k -= 10) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rC0_0 += rA0 * rB0;
               rB3 = *pB3;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[2];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rB2 = pB2[4];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[4];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB1[6];
               rB2 = pB2[6];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[6];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rB1 = pB1[8];
               rB2 = pB2[8];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[8];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rB1 = pB1[10];
               rB2 = pB2[10];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[10];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rB1 = pB1[12];
               rB2 = pB2[12];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[12];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rB1 = pB1[14];
               rB2 = pB2[14];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[14];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rB1 = pB1[16];
               rB2 = pB2[16];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[16];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[18];
               rB0 = pB0[18];
               rB1 = pB1[18];
               rB2 = pB2[18];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[18];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               pA0 += incAk;
               pB0 += incBk;
               pB1 += incBk;
               pB2 += incBk;
               pB3 += incBk;
            }
            switch(k = (K-Kb))
            {
            case 1:
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rC0_0 += rA0 * rB0;
               rB3 = *pB3;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               break;
            case 2:
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rC0_0 += rA0 * rB0;
               rB3 = *pB3;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[2];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               break;
            case 3:
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rC0_0 += rA0 * rB0;
               rB3 = *pB3;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[2];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rB2 = pB2[4];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[4];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               break;
            case 4:
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rC0_0 += rA0 * rB0;
               rB3 = *pB3;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[2];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rB2 = pB2[4];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[4];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB1[6];
               rB2 = pB2[6];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[6];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               break;
            case 5:
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rC0_0 += rA0 * rB0;
               rB3 = *pB3;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[2];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rB2 = pB2[4];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[4];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB1[6];
               rB2 = pB2[6];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[6];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rB1 = pB1[8];
               rB2 = pB2[8];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[8];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               break;
            case 6:
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rC0_0 += rA0 * rB0;
               rB3 = *pB3;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[2];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rB2 = pB2[4];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[4];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB1[6];
               rB2 = pB2[6];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[6];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rB1 = pB1[8];
               rB2 = pB2[8];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[8];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rB1 = pB1[10];
               rB2 = pB2[10];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[10];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               break;
            case 7:
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rC0_0 += rA0 * rB0;
               rB3 = *pB3;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[2];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rB2 = pB2[4];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[4];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB1[6];
               rB2 = pB2[6];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[6];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rB1 = pB1[8];
               rB2 = pB2[8];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[8];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rB1 = pB1[10];
               rB2 = pB2[10];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[10];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rB1 = pB1[12];
               rB2 = pB2[12];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[12];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               break;
            case 8:
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rC0_0 += rA0 * rB0;
               rB3 = *pB3;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[2];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rB2 = pB2[4];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[4];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB1[6];
               rB2 = pB2[6];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[6];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rB1 = pB1[8];
               rB2 = pB2[8];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[8];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rB1 = pB1[10];
               rB2 = pB2[10];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[10];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rB1 = pB1[12];
               rB2 = pB2[12];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[12];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rB1 = pB1[14];
               rB2 = pB2[14];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[14];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               break;
            case 9:
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rC0_0 += rA0 * rB0;
               rB3 = *pB3;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[2];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rB2 = pB2[4];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[4];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB1[6];
               rB2 = pB2[6];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[6];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rB1 = pB1[8];
               rB2 = pB2[8];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[8];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rB1 = pB1[10];
               rB2 = pB2[10];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[10];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rB1 = pB1[12];
               rB2 = pB2[12];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[12];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rB1 = pB1[14];
               rB2 = pB2[14];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[14];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rB1 = pB1[16];
               rB2 = pB2[16];
               rC0_0 += rA0 * rB0;
               rB3 = pB3[16];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               break;
            case 0: ;
            }
            rB0 = alpha;
            rC0_0 *= rB0;
            rC0_1 *= rB0;
            rC0_2 *= rB0;
            rC0_3 *= rB0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            *pC3 = rC0_3;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pA0 += incAm;
            pB0 += incBm;
            pB1 += incBm;
            pB2 += incBm;
            pB3 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pA0 += incAn;
         pB0 += incBn;
         pB1 += incBn;
         pB2 += incBn;
         pB3 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_zJIK0x0x0TN1x1x10_aX_bX(M, k, K, alpha, ca, lda, cb + (((Nb*ldb) << 1)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
