#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x0x0TT1x1x1_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=512
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const double *stM = A + (((lda*Mb) << 1));
   const double *stN = B + (((Nb) << 1));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 2
   const int incAm = ((((lda) - Kb) << 1)), incAn = -(((Mb*lda) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(((Kb*ldb) << 1));
   #define incBn 2
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=K; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            pA0 += incAk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x0x0TT1x1x24_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=24, pf=512
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const int Kloop = ((K-2)/24)*24, kr = K - Kloop - 2;
   const double *stM = A + (((lda*Mb) << 1));
   const double *stN = B + (((Nb) << 1));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 48
   const int incAm = ((((lda) - Kb) << 1)), incAn = -(((Mb*lda) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(((Kb*ldb) << 1));
   #define incBn 2
   const int incAk0 = ((incAk) / 24);
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double m0;
   register double rC0_0;
   if (K < 3)
   {
      ATL_zJIK0x0x0TT1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         pB0 += incBk0;
         rA0 = pA0[2];
         rB0 = *pB0;

         pA0 += (incAk0);
         for (k=Kloop; k; k -= 24) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[24];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[26];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[28];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[30];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[32];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[34];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[36];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[38];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[40];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[42];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[44];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[46];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[48];
            rB0 = *pB0;
            pA0 += incAk;
         } /* end K-loop */
         switch(kr)
         {
         case 1:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            pA0 += (incAk0);
            break;
         case 2:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            pA0 += (((incAk0) << 1));
            break;
         case 3:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            pA0 += (((incAk0) << 1)+incAk0);
            break;
         case 4:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            pA0 += (((incAk0) << 2));
            break;
         case 5:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            pA0 += (((incAk0) << 2)+incAk0);
            break;
         case 6:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            pA0 += (((incAk0) << 2)+((incAk0) << 1));
            break;
         case 7:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            pA0 += (7*(incAk0));
            break;
         case 8:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            pA0 += (((incAk0) << 3));
            break;
         case 9:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            pA0 += (((incAk0) << 3)+incAk0);
            break;
         case 10:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            pA0 += (((incAk0) << 3)+((incAk0) << 1));
            break;
         case 11:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            pA0 += (11*(incAk0));
            break;
         case 12:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[24];
            rB0 = *pB0;
            pA0 += (((incAk0) << 3)+((incAk0) << 2));
            break;
         case 13:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[24];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[26];
            rB0 = *pB0;
            pA0 += (13*(incAk0));
            break;
         case 14:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[24];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[26];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[28];
            rB0 = *pB0;
            pA0 += (14*(incAk0));
            break;
         case 15:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[24];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[26];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[28];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[30];
            rB0 = *pB0;
            pA0 += (15*(incAk0));
            break;
         case 16:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[24];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[26];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[28];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[30];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[32];
            rB0 = *pB0;
            pA0 += (((incAk0) << 4));
            break;
         case 17:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[24];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[26];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[28];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[30];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[32];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[34];
            rB0 = *pB0;
            pA0 += (((incAk0) << 4)+incAk0);
            break;
         case 18:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[24];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[26];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[28];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[30];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[32];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[34];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[36];
            rB0 = *pB0;
            pA0 += (((incAk0) << 4)+((incAk0) << 1));
            break;
         case 19:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[24];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[26];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[28];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[30];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[32];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[34];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[36];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[38];
            rB0 = *pB0;
            pA0 += (19*(incAk0));
            break;
         case 20:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[24];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[26];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[28];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[30];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[32];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[34];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[36];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[38];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[40];
            rB0 = *pB0;
            pA0 += (((incAk0) << 4)+((incAk0) << 2));
            break;
         case 21:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[24];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[26];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[28];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[30];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[32];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[34];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[36];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[38];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[40];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[42];
            rB0 = *pB0;
            pA0 += (21*(incAk0));
            break;
         case 22:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[24];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[26];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[28];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[30];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[32];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[34];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[36];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[38];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[40];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[42];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[44];
            rB0 = *pB0;
            pA0 += (22*(incAk0));
            break;
         case 23:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[24];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[26];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[28];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[30];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[32];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[34];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[36];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[38];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[40];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[42];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[44];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[46];
            rB0 = *pB0;
            pA0 += (23*(incAk0));
            break;
         case 0: ;
         }
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         pB0 += incBk0;
         rC0_0 += m0;
         pA0 += incAk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK0x0x0TT0x0x0_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=1, ku=24, pf=512
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const int Mb = (M>>1)<<1;
   #define Nb N
   #define Kb K
   const int Kloop = ((K-2)/24)*24, kr = K - Kloop - 2;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((lda*Mb) << 1));
   const double *stN = B + (((Nb) << 1));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 48
   const int incAm = ((((((lda) << 1)) - Kb) << 1)), incAn = -(((Mb*lda) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(((Kb*ldb) << 1));
   #define incBn 2
   const int incAk0 = ((incAk) / 24);
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A, *pA1=pA0+(((lda) << 1));
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0;
   register double m0, m1;
   register double rC0_0, rC1_0;
   if (K < 3)
   {
      ATL_zJIK0x0x0TT1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+8);
         ATL_pfl1R(pfA+16);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[2];
            rC1_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            m0 = rA0 * rB0;
            rA1 = *pA1;
            m1 = rA1 * rB0;
            pB0 += incBk0;
            rA0 = pA0[2];
            rB0 = *pB0;
            rA1 = pA1[2];

            pA0 += (incAk0);
            pA1 += (incAk0);
            for (k=Kloop; k; k -= 24) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[24];
               rB0 = *pB0;
               rA1 = pA1[24];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[26];
               rB0 = *pB0;
               rA1 = pA1[26];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[28];
               rB0 = *pB0;
               rA1 = pA1[28];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[30];
               rB0 = *pB0;
               rA1 = pA1[30];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[32];
               rB0 = *pB0;
               rA1 = pA1[32];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[34];
               rB0 = *pB0;
               rA1 = pA1[34];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[36];
               rB0 = *pB0;
               rA1 = pA1[36];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[38];
               rB0 = *pB0;
               rA1 = pA1[38];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[40];
               rB0 = *pB0;
               rA1 = pA1[40];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[42];
               rB0 = *pB0;
               rA1 = pA1[42];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[44];
               rB0 = *pB0;
               rA1 = pA1[44];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[46];
               rB0 = *pB0;
               rA1 = pA1[46];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[48];
               rB0 = *pB0;
               rA1 = pA1[48];
               pA0 += incAk;
               pA1 += incAk;
            } /* end K-loop */
            switch(kr)
            {
            case 1:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               pA0 += (incAk0);
               pA1 += (incAk0);
               break;
            case 2:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               pA0 += (((incAk0) << 1));
               pA1 += (((incAk0) << 1));
               break;
            case 3:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               pA0 += (((incAk0) << 1)+incAk0);
               pA1 += (((incAk0) << 1)+incAk0);
               break;
            case 4:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               pA0 += (((incAk0) << 2));
               pA1 += (((incAk0) << 2));
               break;
            case 5:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               pA0 += (((incAk0) << 2)+incAk0);
               pA1 += (((incAk0) << 2)+incAk0);
               break;
            case 6:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               pA0 += (((incAk0) << 2)+((incAk0) << 1));
               pA1 += (((incAk0) << 2)+((incAk0) << 1));
               break;
            case 7:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               pA0 += (7*(incAk0));
               pA1 += (7*(incAk0));
               break;
            case 8:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               pA0 += (((incAk0) << 3));
               pA1 += (((incAk0) << 3));
               break;
            case 9:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               pA0 += (((incAk0) << 3)+incAk0);
               pA1 += (((incAk0) << 3)+incAk0);
               break;
            case 10:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               pA0 += (((incAk0) << 3)+((incAk0) << 1));
               pA1 += (((incAk0) << 3)+((incAk0) << 1));
               break;
            case 11:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               pA0 += (11*(incAk0));
               pA1 += (11*(incAk0));
               break;
            case 12:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[24];
               rB0 = *pB0;
               rA1 = pA1[24];
               pA0 += (((incAk0) << 3)+((incAk0) << 2));
               pA1 += (((incAk0) << 3)+((incAk0) << 2));
               break;
            case 13:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[24];
               rB0 = *pB0;
               rA1 = pA1[24];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[26];
               rB0 = *pB0;
               rA1 = pA1[26];
               pA0 += (13*(incAk0));
               pA1 += (13*(incAk0));
               break;
            case 14:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[24];
               rB0 = *pB0;
               rA1 = pA1[24];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[26];
               rB0 = *pB0;
               rA1 = pA1[26];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[28];
               rB0 = *pB0;
               rA1 = pA1[28];
               pA0 += (14*(incAk0));
               pA1 += (14*(incAk0));
               break;
            case 15:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[24];
               rB0 = *pB0;
               rA1 = pA1[24];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[26];
               rB0 = *pB0;
               rA1 = pA1[26];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[28];
               rB0 = *pB0;
               rA1 = pA1[28];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[30];
               rB0 = *pB0;
               rA1 = pA1[30];
               pA0 += (15*(incAk0));
               pA1 += (15*(incAk0));
               break;
            case 16:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[24];
               rB0 = *pB0;
               rA1 = pA1[24];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[26];
               rB0 = *pB0;
               rA1 = pA1[26];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[28];
               rB0 = *pB0;
               rA1 = pA1[28];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[30];
               rB0 = *pB0;
               rA1 = pA1[30];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[32];
               rB0 = *pB0;
               rA1 = pA1[32];
               pA0 += (((incAk0) << 4));
               pA1 += (((incAk0) << 4));
               break;
            case 17:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[24];
               rB0 = *pB0;
               rA1 = pA1[24];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[26];
               rB0 = *pB0;
               rA1 = pA1[26];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[28];
               rB0 = *pB0;
               rA1 = pA1[28];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[30];
               rB0 = *pB0;
               rA1 = pA1[30];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[32];
               rB0 = *pB0;
               rA1 = pA1[32];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[34];
               rB0 = *pB0;
               rA1 = pA1[34];
               pA0 += (((incAk0) << 4)+incAk0);
               pA1 += (((incAk0) << 4)+incAk0);
               break;
            case 18:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[24];
               rB0 = *pB0;
               rA1 = pA1[24];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[26];
               rB0 = *pB0;
               rA1 = pA1[26];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[28];
               rB0 = *pB0;
               rA1 = pA1[28];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[30];
               rB0 = *pB0;
               rA1 = pA1[30];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[32];
               rB0 = *pB0;
               rA1 = pA1[32];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[34];
               rB0 = *pB0;
               rA1 = pA1[34];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[36];
               rB0 = *pB0;
               rA1 = pA1[36];
               pA0 += (((incAk0) << 4)+((incAk0) << 1));
               pA1 += (((incAk0) << 4)+((incAk0) << 1));
               break;
            case 19:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[24];
               rB0 = *pB0;
               rA1 = pA1[24];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[26];
               rB0 = *pB0;
               rA1 = pA1[26];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[28];
               rB0 = *pB0;
               rA1 = pA1[28];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[30];
               rB0 = *pB0;
               rA1 = pA1[30];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[32];
               rB0 = *pB0;
               rA1 = pA1[32];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[34];
               rB0 = *pB0;
               rA1 = pA1[34];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[36];
               rB0 = *pB0;
               rA1 = pA1[36];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[38];
               rB0 = *pB0;
               rA1 = pA1[38];
               pA0 += (19*(incAk0));
               pA1 += (19*(incAk0));
               break;
            case 20:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[24];
               rB0 = *pB0;
               rA1 = pA1[24];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[26];
               rB0 = *pB0;
               rA1 = pA1[26];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[28];
               rB0 = *pB0;
               rA1 = pA1[28];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[30];
               rB0 = *pB0;
               rA1 = pA1[30];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[32];
               rB0 = *pB0;
               rA1 = pA1[32];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[34];
               rB0 = *pB0;
               rA1 = pA1[34];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[36];
               rB0 = *pB0;
               rA1 = pA1[36];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[38];
               rB0 = *pB0;
               rA1 = pA1[38];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[40];
               rB0 = *pB0;
               rA1 = pA1[40];
               pA0 += (((incAk0) << 4)+((incAk0) << 2));
               pA1 += (((incAk0) << 4)+((incAk0) << 2));
               break;
            case 21:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[24];
               rB0 = *pB0;
               rA1 = pA1[24];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[26];
               rB0 = *pB0;
               rA1 = pA1[26];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[28];
               rB0 = *pB0;
               rA1 = pA1[28];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[30];
               rB0 = *pB0;
               rA1 = pA1[30];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[32];
               rB0 = *pB0;
               rA1 = pA1[32];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[34];
               rB0 = *pB0;
               rA1 = pA1[34];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[36];
               rB0 = *pB0;
               rA1 = pA1[36];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[38];
               rB0 = *pB0;
               rA1 = pA1[38];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[40];
               rB0 = *pB0;
               rA1 = pA1[40];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[42];
               rB0 = *pB0;
               rA1 = pA1[42];
               pA0 += (21*(incAk0));
               pA1 += (21*(incAk0));
               break;
            case 22:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[24];
               rB0 = *pB0;
               rA1 = pA1[24];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[26];
               rB0 = *pB0;
               rA1 = pA1[26];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[28];
               rB0 = *pB0;
               rA1 = pA1[28];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[30];
               rB0 = *pB0;
               rA1 = pA1[30];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[32];
               rB0 = *pB0;
               rA1 = pA1[32];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[34];
               rB0 = *pB0;
               rA1 = pA1[34];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[36];
               rB0 = *pB0;
               rA1 = pA1[36];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[38];
               rB0 = *pB0;
               rA1 = pA1[38];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[40];
               rB0 = *pB0;
               rA1 = pA1[40];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[42];
               rB0 = *pB0;
               rA1 = pA1[42];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[44];
               rB0 = *pB0;
               rA1 = pA1[44];
               pA0 += (22*(incAk0));
               pA1 += (22*(incAk0));
               break;
            case 23:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[24];
               rB0 = *pB0;
               rA1 = pA1[24];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[26];
               rB0 = *pB0;
               rA1 = pA1[26];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[28];
               rB0 = *pB0;
               rA1 = pA1[28];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[30];
               rB0 = *pB0;
               rA1 = pA1[30];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[32];
               rB0 = *pB0;
               rA1 = pA1[32];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[34];
               rB0 = *pB0;
               rA1 = pA1[34];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[36];
               rB0 = *pB0;
               rA1 = pA1[36];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[38];
               rB0 = *pB0;
               rA1 = pA1[38];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[40];
               rB0 = *pB0;
               rA1 = pA1[40];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[42];
               rB0 = *pB0;
               rA1 = pA1[42];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[44];
               rB0 = *pB0;
               rA1 = pA1[44];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               pB0 += incBk;
               rA0 = pA0[46];
               rB0 = *pB0;
               rA1 = pA1[46];
               pA0 += (23*(incAk0));
               pA1 += (23*(incAk0));
               break;
            case 0: ;
            }
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            pB0 += incBk0;
            rC0_0 += m0;
            rC1_0 += m1;
            pA0 += incAk0;
            pA1 += incAk0;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0 += incCm;
            pA0 += incAm;
            pA1 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pA1 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_zJIK0x0x0TT1x1x24_aX_bX(k, N, K, alpha, ca + (((Mb*lda) << 1)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
