#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_zJIK24x24x24NT0x0x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=24, NB=24, KB=24, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=1, ku=24, pf=512
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const double *stM = A + 48;
   const double *stN = B + 48;
   const double *pfA = A + lda*M;
   const int incAk = (((lda) << 1));
   const int incAm = 4 - (((lda) << 5)+((lda) << 4)), incAn = -48;
   const int incBk = (((ldb) << 1)), incBm = -(((ldb) << 5)+((ldb) << 4));
   #define incBn 2
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (((ldc) << 1)) - 48;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0;
   register double m0, m1, m2;
   register double rC0_0, rC1_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         ATL_pfl1W(pC0);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA1 = pA0[2];
         m1 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         m2 = rA0 * rB0;

/*
 *       Completely unrolled K-loop
 */
         rC0_0 = m0;
         m0 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 = m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC1_0 += m1;
         m1 = rA0 * rB0;
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m2;
         m2 = rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rC1_0 += m0;
         rC0_0 += m1;
         rC1_0 += m2;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
