#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x0x19TN1x1x19_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=19, 
 * lda=19, ldb=19, ldc=0, mu=1, nu=1, ku=19, pf=512
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   #define Nb N
   const double *stM = A + (19*(Mb));
   const double *stN = B + (19*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 19
   const int incAm = 0, incAn = -(19*(Mb));
   #define incBk 19
   const int incBm = -19, incBn = 19;
   const int incAk0 = ((incAk) / 19), incBk0 = ((incBk) / 19);
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double m0;
   register double rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[18];
         rB0 = pB0[18];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         pA0 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK0x0x19TN19x19x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=19, 
 * lda=19, ldb=19, ldc=0, mu=2, nu=1, ku=19, pf=512
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const int Mb = (M>>1)<<1;
   #define Nb N
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (19*(Mb));
   const double *stN = B + (19*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*1)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 19
   const int incAm = 19, incAn = -(19*(Mb));
   #define incBk 19
   const int incBm = -19, incBn = 19;
   const int incAk0 = ((incAk) / 19), incBk0 = ((incBk) / 19);
   #define incCm 4
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0;
   register double m0, m1, m2;
   register double rC0_0, rC1_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[2];
            rC1_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            m0 = rA0 * rB0;
            rA1 = pA0[19];
            m1 = rA1 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[20];
            m2 = rA0 * rB0;

/*
 *          Completely unrolled K-loop
 */
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[21];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[22];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[23];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[24];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[25];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[26];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA0[27];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rA1 = pA0[28];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rA1 = pA0[29];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rA1 = pA0[30];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rA1 = pA0[31];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rA1 = pA0[32];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rA1 = pA0[33];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rA1 = pA0[34];
            rC1_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rA1 = pA0[35];
            rC1_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rA1 = pA0[36];
            rC1_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rA1 = pA0[37];
            rC1_0 += m0;
            m0 = rA0 * rB0;
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            rC0_0 += m0;
            rC1_0 += m1;
            pA0 += incAk;
            pB0 += incBk;
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_zJIK0x0x19TN1x1x19_a1_bX(k, N, 19, alpha, ca + (19*(Mb)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
