#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_zJIK24x0x24TN24x24x0_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=24, NB=0, KB=24, 
 * lda=24, ldb=24, ldc=0, mu=2, nu=1, ku=24, pf=512
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Nb N
   const double *stM = A + 576;
   const double *stN = B + (((Nb) << 4)+((Nb) << 3));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*1)/(24*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 24
   const int incAm = 24, incAn = -576;
   #define incBk 24
   const int incBm = -24, incBn = 24;
   const int incAk0 = ((incAk) / 24), incBk0 = ((incBk) / 24);
   #define incCm 4
   const int incCn = (((ldc) << 1)) - 48;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0;
   register double m0, m1, m2;
   register double rC0_0, rC1_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rC0_0 = *pC0;
         rC1_0 = pC0[2];
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA1 = pA0[24];
         m1 = rA1 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[25];
         m2 = rA0 * rB0;

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA1 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA0[26];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA1 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rA1 = pA0[27];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rA1 = pA0[28];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA1 * rB0;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rA1 = pA0[29];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA1 * rB0;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rA1 = pA0[30];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rA1 = pA0[31];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA1 * rB0;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rA1 = pA0[32];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA1 * rB0;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rA1 = pA0[33];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rA1 = pA0[34];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA1 * rB0;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rA1 = pA0[35];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA1 * rB0;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rA1 = pA0[36];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rA1 = pA0[37];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA1 * rB0;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rA1 = pA0[38];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA1 * rB0;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rA1 = pA0[39];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rA1 = pA0[40];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA1 * rB0;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rA1 = pA0[41];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA1 * rB0;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rA1 = pA0[42];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rA1 = pA0[43];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA1 * rB0;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rA1 = pA0[44];
         rC1_0 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA1 * rB0;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rA1 = pA0[45];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rA1 = pA0[46];
         rC1_0 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA1 * rB0;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rA1 = pA0[47];
         rC1_0 += m1;
         m1 = rA0 * rB0;
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m2;
         m2 = rA1 * rB0;
         rC1_0 += m0;
         rC0_0 += m1;
         rC1_0 += m2;
         pA0 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANN
#define ATL_zpNBmm_b1 ATL_zgpNBmm_b1
#endif

void ATL_zJIK24x0x24TN24x24x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK24x0x24TN24x24x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK24x0x24TN24x24x0_a1_b1(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);

void ATL_zpNBmm_b1(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc)
{
   ATL_zJIK24x0x24TN24x24x0_a1_bX(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_zJIK24x0x24TN24x24x0_a1_bX(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_zJIK24x0x24TN24x24x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_zJIK24x0x24TN24x24x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
