#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_zJIK24x24x24NN0x0x0_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=24, NB=24, KB=24, 
 * lda=0, ldb=0, ldc=0, mu=6, nu=1, ku=24, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const double *stM = A + 48;
   const double *stN = B + (((ldb) << 5)+((ldb) << 4));
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 12 - (((lda) << 5)+((lda) << 4)), incAn = -48;
   #define incBk 48
   const int incBm = -48, incBn = (((ldb) << 1));
   #define incCm 12
   const int incCn = (((ldc) << 1)) - 48;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[2];
         rC1_0 *= rA0;
         rC2_0 = pC0[4];
         rC2_0 *= rA0;
         rC3_0 = pC0[6];
         rC3_0 *= rA0;
         rC4_0 = pC0[8];
         rC4_0 *= rA0;
         rC5_0 = pC0[10];
         rC5_0 *= rA0;
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[2];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[4];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[6];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[8];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[10];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[12];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[14];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[16];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[18];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[20];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[22];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[24];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[26];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[28];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[30];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[32];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[34];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[36];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[38];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[40];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[42];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[44];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[46];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rC2_0 += rA2 * rB0;
         rA5 = pA0[10];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC1_0 *= rB0;
         rC2_0 *= rB0;
         rC3_0 *= rB0;
         rC4_0 *= rB0;
         rC5_0 *= rB0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0[8] = rC4_0;
         pC0[10] = rC5_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
